/*
 * ThinkRequest.java
 *
 * Created on 3. mai 2007, 11:44
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package thinkAlike;

import java.io.IOException;

/**
 *
 * @author Runar Gunnerud
 *
 */
public class ThinkRequest {
    
    private ProgramControl pc;
    private String to, from, pic, thinkword, word1, word2, word3;
    private boolean isInitiator = false;
    
    /** Creates a new instance of ThinkRequest */
    public ThinkRequest(ProgramControl pc, String to, String from, String pic, String thinkword) {
        this.pc = pc;
        this.to = to;
        this.from = from;
        this.pic = pic;
        this.thinkword = thinkword;
    }
    
    // Askes the user if he wants to accept the challenge
    public void confirmRequest(){
        pc.getSc().get_fromUserString().setText(this.from); 
        pc.getSc().getDisplay().setCurrent(pc.getSc().get_recievedChallengeForm());
        pc.getSc().getDisplay().vibrate(2000);
        pc.getSc().getDisplay().flashBacklight(3000);
    }
    
    public void requestConfirmed(){
    }
    
    public void sendThinkRequest() throws IOException{
        pc.getJxa().sendThinkRequest(this.to, this.from, this.pic, this.thinkword);
    }

    public void recievedResponse(String word1, String word2, String word3){
        setWords(word1, word2, word3);
        pc.getSc().get_word1Recieved().setLabel("First word:");
        pc.getSc().get_word1Recieved().setText(word1);
        pc.getSc().get_word2Recieved().setLabel("Second word:");
        pc.getSc().get_word2Recieved().setText(word2);
        pc.getSc().get_word3Recieved().setLabel("Third word:");
        pc.getSc().get_word3Recieved().setText(word3);
        
        String resultTxt = calculateResult();
        
        pc.getSc().get_resultRequestString().setText(resultTxt);
//        pc.getSc().getDisplay().setCurrent(pc.getSc().get_resultForm());
    }
    
    public void makeResultForm(){
        String resultTxt = calculateResult();
        pc.getSc().get_theWordRecieverString().setText(thinkword);
        pc.getSc().get_suggestedWordsRecieverString().setText(word1 + " " + word2 + " " + word3);
        pc.getSc().get_resultRecieverString().setText(resultTxt);
    }

    public void makeEndForm(){
        String resultTxt = calculateResult();
        pc.getSc().get_initialWordString().setText(thinkword);
        pc.getSc().get_suggestedWordsEndString().setText(word1 + " " + word2 + " " + word3);
                
    }

    public String calculateResult() {
        if(thinkword.equals(word1) || thinkword.equals(word2) || thinkword.equals(word3)){
            return "Yo you rock! and ThinkAlike!";
        }
        else {
            return "You're soooo far off!";
        }
    }
    
    //notice that the response is sent back to the requester, therefore the to field of the message is the from variable in the ThinkRequest calss
    public void sendWords() throws IOException{
        pc.getJxa().sendThinkRespond(this.from, this.to, this.word1, this.word2, this.word3); 
    }
    
    public void isInitiator(boolean is){
        this.isInitiator = is;
    }
    
    public boolean isInitiator(){
        return this.isInitiator;
    }

    public void setWords(String word1, String word2, String word3){
        this.word1 = word1;
        this.word2 = word2;
        this.word3 = word3;
    }
       
    public String getTo(){
        return to;
    }
    public String getFrom(){
        return from;
    }
    public String getPic(){
        return pic;
    }
    public String getThinkWord(){
        return thinkword;
    }
    public String getWord1(){
        return word1;
    }
    public String getWord2(){
        return word2;
    }
    public String getWord3(){
        return word3;
    }



}
