/*
 * programControl.java
 *
 * Created on 19. april 2007, 15:40
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package thinkAlike;

//import context.*;
import java.io.IOException;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.Item;
import javax.microedition.media.*;
import javax.microedition.media.control.*;
import net.sourceforge.jxa.*;


    



/**
 *
 * @author runar
 */
public class ProgramControl implements XmppListener {
    
    private Words words;
    private ThinkRequest thinkRequest;
    private Jxa jxa;
    private ScreenControl sc;
    private Player mPlayer;
    private VideoControl mVideoControl;
    
    private String host = "horus.nta.no";
    private String port = "5222";
    private String username = "test";
    private String password = "passord";
    private String resource = "thinkalike";
    private int priority = 5;
    
    private String replyMessage;
    private String chatlog = ""; //
    private byte[] rawImage = null;
    private Image image = null;
   
    /** Creates a new instance of programControl */
    public ProgramControl(ScreenControl sc) {
        this.sc = sc;
        this.words = new Words();
    }
    
    public boolean connect() throws IOException{
        jxa = new Jxa(host,port,username,password,resource,priority);
        jxa.addListener(this);
        return true;
    }
    
    public boolean sendMessage(String to, String message){
        jxa.sendMessage(to, message);
        return false;
    }
    
    public boolean sendTulleMelding(){
        jxa.sendMessage("test1@horus.nta.no",words.toString());
        return false;
    }
    
    public boolean setStatus(String show, String status, int priority){
        jxa.setStatus(show,status,5);
        return false;
    }
    
    public void setLoginParameters(String host, String port, String username, String password, String resource){
        this.host = host;
        this.port = port;
        this.username = username;
        this.password = password;
        this.resource = resource;
    }
    
    public Words getWords(){
        return words;
    }
    
    public String getReplyMessage(){
        return replyMessage;
    }
    
    /*
     * This method gives classes like ThinkRequest access to the ScreenControl class
     */
    public ScreenControl getSc(){ 
        return sc;
    }
    
    public Jxa getJxa(){
        return jxa;
    }
    
    public ThinkRequest getThinkRequest(){
        return thinkRequest;
    }
    
    public void clearThinkAlikeSession(){
        thinkRequest = null;
        chatlog = "";
    }
    
    public void makeThinkRequest(String to, String from, String pic, String thinkword){
        if(from == null){
            from = this.username;
        }
        if(pic == null){ // when Requester
//            String tempImageString = Base64Big.toString(rawImage);
            String tempImageString = Base64.encode(rawImage);
//            java.lang.System.out.println("bilde i tekst: " + tempImageString);

            thinkRequest = new ThinkRequest(this, to, from, tempImageString, thinkword);
        }
        else{ // when Reciever
            java.lang.System.out.println("Dette er lengden p mottatt pic String" + pic.length());
//            rawImage = Base64Big.fromString(pic);
            rawImage = Base64.decode(pic);
            image = Image.createImage(rawImage, 0, rawImage.length);
            thinkRequest = new ThinkRequest(this, username, from, pic, thinkword);
          
            java.lang.System.out.println("Dette er bredden p bildet som er mottat: " + image.getWidth());
            
        }
    }
    
    public void sendChatMessage(){
        if(thinkRequest.isInitiator()){
            jxa.sendMessage(thinkRequest.getTo(),sc.get_chatField().getString());
        }
        else {
            jxa.sendMessage(thinkRequest.getFrom(),sc.get_chatField().getString());
        }
        chatlog += username + ": " + sc.get_chatField().getString() + "\n";
        sc.get_chatField().setString("");
        sc.get_chatString().setText(chatlog);        
    }
    
    /**
     * The next three methods are related to Camerafunctions, capturing the picture
     *
     */
    
    public void initilizaCamera() {
       try {
            mPlayer = Manager.createPlayer("capture://video");
            mPlayer.realize();
            mPlayer.start();
        } catch (MediaException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        mVideoControl = (VideoControl) mPlayer.getControl("VideoControl");
     }

    public Item getCameraItem() {
        Item item = (Item)mVideoControl.initDisplayMode(GUIControl.USE_GUI_PRIMITIVE, null);
        return item;
    }
    
    public void captureImage() {
        try {
// Get the image.
            rawImage = mVideoControl.getSnapshot(null);
            image = Image.createImage(rawImage, 0, rawImage.length);
//            java.lang.System.out.println("Dette er det som er lagret i rawImage: " + rawImage.toString());
            java.lang.System.out.println("Dette er lenden p byten...: " + rawImage.length);
            java.lang.System.out.println("Dette er bredden p bildet i image: " + image.getWidth());
            
//            Image image = Image.createImage(raw, 0, raw.length);

            mPlayer.close();
            mPlayer = null;
            mVideoControl = null;
            
            
        } catch (MediaException me){
            java.lang.System.out.println("*error* capturing image, error message: " + me.toString());
        }
    }
    
    public Image getImage(){
        if(image != null){
            return image;
        }
        else{
            return null;
        }
    }
    
    public void setWords(){
        thinkRequest.setWords(sc.get_thinkOfWord1().getString(),sc.get_thinkOfWord2().getString(),sc.get_thinkOfWord3().getString());
    }
    
    public void onConnFailed() {
        java.lang.System.out.println("*debug* connection failed");
        replyMessage = "Connection failed";
    }

    public void onAuth() {
        java.lang.System.out.println("*debug* authorized");
    }

    public void onAuthFailed(final String message) {
        java.lang.System.out.println("*debug* authorization failed with message:" + message);
    }

    public void onMessageEvent(final String from, final String body) {
        chatlog += from + ": " + body + "\n";
        sc.get_chatString().setText(chatlog);

    //    sc.get_fromAdress().setText(from);
    //    sc.get_innMessage().setText(body);
    //    sc.getDisplay().setCurrent(sc.get_messageInn());
//        java.lang.System.out.println("*debug* message event from " + from + " saying " + body);
    }

    public void onContactRemoveEvent(final String jid) {
    }

    public void onContactEvent(final String jid, final String name, final String group, final String subscription) {
    }

    public void onStatusEvent(final String jid, final String show, final String status) {
    }

    public void onSubscribeEvent(final String jid) {
    }

    public void onUnsubscribeEvent(final String jid) {
    }
    
    public void onThinkEvent(final String thinktype, final String from, final String pic, final String thinkword, final String word1, final String word2, final String word3){
        if(thinktype.equals("thinkrequest")){
            
            makeThinkRequest(this.username, from, pic, thinkword);
            
            if (Jxa.DEBUG) java.lang.System.out.println("*debug* rett fr confirmRequest blir kjrt i onThinkEvent");     
            
            
            thinkRequest.isInitiator(false);
            thinkRequest.confirmRequest();
            
            sc.get_fromUserString().setText(from);
            sc.getDisplay().setCurrent(sc.get_recievedChallengeForm());

        }
        else if(thinktype.equals("thinkresponse")){
            thinkRequest.recievedResponse(word1, word2, word3);
            thinkRequest.isInitiator(true);
            if (Jxa.DEBUG) java.lang.System.out.println("*debug* recieved respons from challenged friend. words are" + word1 + " "+ word2 + " " + word3);
        }
   }

    
}






