/*
 * Copyright 2006 Dustin Hass, Sven Jost, Swen Kummer
 * http://sourceforge.net/projects/jxa
 *
 * This file is part of JXAC. JXAC is free software, developed at university.
 * You can redistribute it and/or modify it under the terms of the GNU General 
 * Public License as published by the Free Software Foundation; 
 * either version 2 of the License, or (at your option) any later version.
 * JXAC is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License along with mobber;
 * if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA .
 */


import net.sourceforge.jxa.*;
import java.io.IOException;
import java.util.Calendar;
import java.util.Date;
import java.util.Hashtable;
import javax.microedition.m3g.CompositingMode;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

/** JXAC - JXA Client
 *  We created the jxac for testing our J2ME Jabber API.JXAC is designed for
 *  all MIDP 2 mobile phones. It was developed on Siemens S65, so the best
 *  screen size would be 176x220 ( with x heigh ). But this will have most
 *  effect on splash screen at start. We designed the menue simple as list
 *  and we used the well known short message textbox as chat textbox. The
 *  chat window consists of three areas: on the top a string with all send
 *  and received messages. Below is a string, that you can input text and
 *  a prompt for input text apears at last.
 *  All menues and textboxes are scaled for your device. So you will always
 *  have best fit on your mobile device screen.
 *
 *  splash screen:
 *	is shown on start of jxac for five seconds.
 *
 *  mainForm:
 *  has menue to choose between login (loginForm), configuration (configurationForm)
 *	and exit.
 *
 *  loginForm:
 *	here you can change user details like jabber id, jabber server and your password.
 *      If your are finished, you can connect (Waitscreen_login).
 *	On login, a new instance of jxa will be created with tF_jserver, port (5222),
 *	tF_jid, tF_jpw, ressource (mobile) and priority.
 *
 *  Waitscreen_login:
 *	here you can wait :-) until jxac is connected or the login is failed. On failed
 *	login, you will be back at loginForm else on presence.
 *
 * @author Dustin Hass, Sven Jost, Swen Kummer
 * @version 1.0
 * @since JXA 1.0
 *
 */
 
 
public class jxac extends MIDlet implements CommandListener, XmppListener, ItemCommandListener {
	Roster roster = new Roster();

	Hashtable shows = new Hashtable();

	/** Creates a new instance of jxac */
	public jxac() {
		this.shows.put("", new Integer(0));
		this.shows.put("chat", new Integer(1));
		this.shows.put("away", new Integer(2));
		this.shows.put("xa", new Integer(3));
		this.shows.put("dnd", new Integer(4));
	}

	private Image splashScreen_logo;// GEN-BEGIN:MVDFields

	private org.netbeans.microedition.lcdui.SplashScreen splashScreen;

	private Form loginForm;

	private Command backC_to_main;

	private TextField tF_jid;

	private TextField tF_jpw;

	private Command helpC_login;

	private List mainForm;

	private List buddylist;

	private Image image_login;

	private Image image_configuration;

	private List configurationForm;

	private Alert alert_login;

	private Command sendenC;

	private Command buddyC_del;

	private Command buddyC_info;

	private Command buddyC_to_add;

	private Alert login_success;

	private Command buddyC_message;

	private Form buddyAddForm;

	private TextField tF_addbuddy_jid;

	private Command backC_to_buddy;

	private Command buddyC_add;

	private Command backC_logout;

	private TextField tF_jserver;

	private TextField tF_jressource;

	private Command PrecenseC;

	private Form presence;

	private ChoiceGroup cG_status;

	private Image image_exit;

	private Image image_back;

	private Image image_new;

	private Image image_edit;

	private Image image_S_invisible;

	private Image image_S_away;

	private Image image_S_xa;

	private Image image_S_dnd;

	private Image image_S_online;

	private Command loginC;

	private TextField tF_addbuddy_name;

	private ChoiceGroup cG_addbuddy_group;

	private Spacer spacer1;

	private Spacer spacer2;

	private Spacer spacer3;

	private Spacer spacer4;

	private Spacer spacer5;

	private Form message_Form;

	private TextField tF_message;

	private Spacer spacer6;

	private Command chatC_Senden;

	private Font font_small;

	private StringItem sI_chat;

	private Form Waitscreen_login;

	private StringItem sI_waitscreen;

	private ImageItem imageItem_waitscreen;

	private Image image_waitscreen_login;

	private Command tmp;

	private Command tmpp;

	private Image image_S_chat;

	private Image image_S_message;

	private Spacer spacer7;

	private TextField jpriority;

	private Image image_S_null;

	private Command buddyC_delchat;

	private Command okC_changeStatus;// GEN-END:MVDFields

	private static Jxa jxa;

	private String rec = "";

	private final String shortjid = "";

	private int selectedbuddy = 0;

	private String strDate = "";

	private final Calendar cal = Calendar.getInstance();

	private String messagesendto = "";

	// GEN-LINE:MVDMethods
	/**
	 * Called by the system to indicate that a command has been invoked on a
	 * particular item.                       
	 * 
	 * @param command the Command that ws invoked
	 * @param item the Item on which the command was invoked
	 */
	public void commandAction(final Command command, final Item item) {// GEN-END:MVDICABegin
		// Insert global pre-action code here
		if (item == this.tF_message) {// GEN-BEGIN:MVDICABody
			if (command == this.chatC_Senden) {// GEN-END:MVDICABody
				// Insert pre-action code here
				// Do nothing//GEN-LINE:MVDICAAction208
				// Insert post-action code here
				this.messageSend();
			}// GEN-BEGIN:MVDICACase208
		}// GEN-END:MVDICACase208
		// Insert global post-action code here
	}// GEN-LINE:MVDICAEnd

	/**
	 * This method initializes UI of the application.                        
	 */
	private void initialize() {// GEN-END:MVDInitBegin
		// Insert pre-init code here
		this.getDisplay().setCurrent(get_splashScreen());// GEN-LINE:MVDInitInit
		// Insert post-init code here
	}// GEN-LINE:MVDInitEnd

	/**
	 * Called by the system to indicate that a command has been invoked on a
	 * particular displayable.                      
	 * 
	 * @param command the Command that ws invoked
	 * @param displayable the Displayable on which the command was invoked
	 */
	public void commandAction(final Command command, final Displayable displayable) {// GEN-END:MVDCABegin
		// Insert global pre-action code here
		if (displayable == this.loginForm) {// GEN-BEGIN:MVDCABody
			if (command == this.helpC_login) {// GEN-END:MVDCABody
				// Insert pre-action code here
				// Do nothing//GEN-LINE:MVDCAAction19
				// Insert post-action code here
			} else if (command == this.backC_to_main) {// GEN-LINE:MVDCACase19
				// Insert pre-action code here
				this.getDisplay().setCurrent(this.get_mainForm());// GEN-LINE:MVDCAAction11
				// Insert post-action code here
			} else if (command == this.loginC) {// GEN-LINE:MVDCACase11
				// Insert pre-action code here
				this.getDisplay().setCurrent(this.get_Waitscreen_login());// GEN-LINE:MVDCAAction186
				// Insert post-action code here
				this.login();
			}// GEN-BEGIN:MVDCACase186
		} else if (displayable == this.mainForm) {
			if (command == List.SELECT_COMMAND) {
				switch (this.get_mainForm().getSelectedIndex()) {
					case 0:// GEN-END:MVDCACase186
						// Insert pre-action code here
						this.getDisplay().setCurrent(this.get_loginForm());// GEN-LINE:MVDCAAction40
						// Insert post-action code here
						break;// GEN-BEGIN:MVDCACase40
					case 1:// GEN-END:MVDCACase40
						// Insert pre-action code here
						this.getDisplay().setCurrent(this.get_configurationForm());// GEN-LINE:MVDCAAction42
						// Insert post-action code here
						break;// GEN-BEGIN:MVDCACase42
					case 2:// GEN-END:MVDCACase42
						// Insert pre-action code here
						this.exitMIDlet();// GEN-LINE:MVDCAAction141
						// Insert post-action code here
						break;// GEN-BEGIN:MVDCACase141
				}
			}
		} else if (displayable == this.configurationForm) {
			if (command == List.SELECT_COMMAND) {
				switch (this.get_configurationForm().getSelectedIndex()) {
					case 1:// GEN-END:MVDCACase141
						// Insert pre-action code here
						this.getDisplay().setCurrent(this.get_mainForm());// GEN-LINE:MVDCAAction146
						// Insert post-action code here
						break;// GEN-BEGIN:MVDCACase146
					case 0:// GEN-END:MVDCACase146
						// Insert pre-action code here
						// Do nothing//GEN-LINE:MVDCAAction160
						// Insert post-action code here
						break;// GEN-BEGIN:MVDCACase160
				}
			}
		} else if (displayable == this.buddylist) {
			if (command == this.buddyC_del) {// GEN-END:MVDCACase160
				// Insert pre-action code here
				// Do nothing//GEN-LINE:MVDCAAction90
				// Insert post-action code here
				this.delBuddy();
			} else if (command == this.buddyC_to_add) {// GEN-LINE:MVDCACase90
				// Insert pre-action code here
				this.getDisplay().setCurrent(this.get_buddyAddForm());// GEN-LINE:MVDCAAction96
				// Insert post-action code here
			} else if (command == this.buddyC_info) {// GEN-LINE:MVDCACase96
				// Insert pre-action code here
				// Do nothing//GEN-LINE:MVDCAAction92
				// Insert post-action code here
			} else if (command == this.buddyC_message) {// GEN-LINE:MVDCACase92
				// Insert pre-action code here
				this.selectedbuddy = this.buddylist.getSelectedIndex();
				if (this.selectedbuddy > 1) {
					this.getDisplay().setCurrent(this.get_message_Form());// GEN-LINE:MVDCAAction112
					// Insert post-action code here
					this.rec = this.buddylist.getString(this.selectedbuddy);
					this.sI_chat.setText(this.roster.get_Messages(this.shortjid(this.rec), this.tF_jid.getString()));
					this.message_Form.setTitle("Chat mit " + this.shortjid(this.rec));
				} else {
					java.lang.System.out.println("Bitte ein Buddy auswhlen!");
				}
			} else if (command == this.backC_logout) {// GEN-LINE:MVDCACase112
				// Insert pre-action code here
				this.getDisplay().setCurrent(this.get_mainForm());// GEN-LINE:MVDCAAction148
				// Insert post-action code here
				this.logout();
			} else if (command == this.PrecenseC) {// GEN-LINE:MVDCACase148
				// Insert pre-action code here
				this.getDisplay().setCurrent(this.get_presence());// GEN-LINE:MVDCAAction164
				// Insert post-action code here
			} else if (command == this.buddyC_delchat) {// GEN-LINE:MVDCACase164
				// Insert pre-action code here
				// Do nothing//GEN-LINE:MVDCAAction245
				this.roster.clear_Messages();
				// /......buddylist durchsuchen .. image setzen
			}// GEN-BEGIN:MVDCACase245
		} else if (displayable == this.buddyAddForm) {
			if (command == this.backC_to_buddy) {// GEN-END:MVDCACase245
				// Insert pre-action code here
				this.getDisplay().setCurrent(this.get_buddylist());// GEN-LINE:MVDCAAction116
				// Insert post-action code here
			} else if (command == this.buddyC_add) {// GEN-LINE:MVDCACase116
				// Insert pre-action code here
				this.getDisplay().setCurrent(this.get_buddylist());// GEN-LINE:MVDCAAction118
				// Insert post-action code here
				this.addBuddy();
			}// GEN-BEGIN:MVDCACase118
		} else if (displayable == this.alert_login) {
			if (command == this.backC_to_main) {// GEN-END:MVDCACase118
				// Insert pre-action code here
				this.getDisplay().setCurrent(this.get_loginForm());// GEN-LINE:MVDCAAction154
				// Insert post-action code here
			}// GEN-BEGIN:MVDCACase154
		} else if (displayable == this.presence) {
			if (command == this.backC_to_buddy) {// GEN-END:MVDCACase154
				// Insert pre-action code here
				this.getDisplay().setCurrent(this.get_buddylist());// GEN-LINE:MVDCAAction182
				// Insert post-action code here
			} else if (command == this.okC_changeStatus) {// GEN-LINE:MVDCACase182
				// Insert pre-action code here
				this.getDisplay().setCurrent(this.get_buddylist());// GEN-LINE:MVDCAAction247
				// Insert post-action code here
				this.changeStatus();
			}// GEN-BEGIN:MVDCACase247
		} else if (displayable == this.message_Form) {
			if (command == this.backC_to_buddy) {// GEN-END:MVDCACase247
				// Insert pre-action code here
				this.getDisplay().setCurrent(this.get_buddylist());// GEN-LINE:MVDCAAction215
				// Insert post-action code here
			}// GEN-BEGIN:MVDCACase215
		} else if (displayable == this.Waitscreen_login) {
			if (command == this.tmp) {// GEN-END:MVDCACase215
				// Insert pre-action code here
				this.getDisplay().setCurrent(this.get_login_success(), this.get_buddylist());// GEN-LINE:MVDCAAction227
				// Insert post-action code here
			} else if (command == this.tmpp) {// GEN-LINE:MVDCACase227
				// Insert pre-action code here
				this.getDisplay().setCurrent(this.get_alert_login());// GEN-LINE:MVDCAAction229
				// Insert post-action code here
			}// GEN-BEGIN:MVDCACase229
		}// GEN-END:MVDCACase229
		// Insert global post-action code here
	}// GEN-LINE:MVDCAEnd

	/**
	 * This method should return an instance of the display.
	 */
	public Display getDisplay() {// GEN-FIRST:MVDGetDisplay
		return Display.getDisplay(this);
	}// GEN-LAST:MVDGetDisplay

	/**
	 * This method should exit the midlet.
	 */
	public void exitMIDlet() {// GEN-FIRST:MVDExitMidlet
		this.getDisplay().setCurrent(null);
		this.destroyApp(true);
		this.notifyDestroyed();
	}// GEN-LAST:MVDExitMidlet

	/**
	 * This method returns instance for splashScreen_logo component and should
	 * be called instead of accessing splashScreen_logo field
	 * directly.                        
	 * 
	 * @return Instance for splashScreen_logo component
	 */
	public Image get_splashScreen_logo() {
		if (this.splashScreen_logo == null) {// GEN-END:MVDGetBegin6
			// Insert pre-init code here
			try {// GEN-BEGIN:MVDGetInit6
				this.splashScreen_logo = Image.createImage("/res/logo_mmp.png");
			} catch (final java.io.IOException exception) {
			}// GEN-END:MVDGetInit6
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd6
		return this.splashScreen_logo;
	}// GEN-END:MVDGetEnd6

	/**
	 * This method returns instance for splashScreen component and should be
	 * called instead of accessing splashScreen field
	 * directly.                        
	 * 
	 * @return Instance for splashScreen component
	 */
	public org.netbeans.microedition.lcdui.SplashScreen get_splashScreen() {
		if (splashScreen == null) {// GEN-END:MVDGetBegin7
			// Insert pre-init code here
			splashScreen = new org.netbeans.microedition.lcdui.SplashScreen(this.getDisplay());// GEN-BEGIN:MVDGetInit7
			splashScreen.setImage(this.get_splashScreen_logo());
			splashScreen.setNextDisplayable(this.get_mainForm());// GEN-END:MVDGetInit7
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd7
		return splashScreen;
	}// GEN-END:MVDGetEnd7

	/**
	 * This method returns instance for loginForm component and should be called
	 * instead of accessing loginForm field directly.                        
	 * 
	 * @return Instance for loginForm component
	 */
	public Form get_loginForm() {
		if (this.loginForm == null) {// GEN-END:MVDGetBegin9
			// Insert pre-init code here
			this.loginForm = new Form("Login", new Item[] {// GEN-BEGIN:MVDGetInit9
			        this.get_tF_jid(), this.get_spacer3(), this.get_tF_jpw(), this.get_spacer4(), this.get_tF_jserver(), this.get_spacer5(), this.get_tF_jressource(), this.get_spacer7(), this.get_jpriority() });
			this.loginForm.addCommand(this.get_backC_to_main());
			this.loginForm.addCommand(this.get_helpC_login());
			this.loginForm.addCommand(this.get_loginC());
			this.loginForm.setCommandListener(this);// GEN-END:MVDGetInit9
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd9
		return this.loginForm;
	}// GEN-END:MVDGetEnd9

	/**
	 * This method returns instance for backC_to_main component and should be
	 * called instead of accessing backC_to_main field
	 * directly.                         
	 * 
	 * @return Instance for backC_to_main component
	 */
	public Command get_backC_to_main() {
		if (this.backC_to_main == null) {// GEN-END:MVDGetBegin10
			// Insert pre-init code here
			this.backC_to_main = new Command("Zur\u00FCck", Command.BACK, 2);// GEN-LINE:MVDGetInit10
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd10
		return this.backC_to_main;
	}// GEN-END:MVDGetEnd10

	/**
	 * This method returns instance for tF_jid component and should be called
	 * instead of accessing tF_jid field directly.                         
	 * 
	 * @return Instance for tF_jid component
	 */
	public TextField get_tF_jid() {
		if (this.tF_jid == null) {// GEN-END:MVDGetBegin16
			// Insert pre-init code here
			this.tF_jid = new TextField("Jabber ID", "", 120, TextField.ANY);// GEN-BEGIN:MVDGetInit16
			this.tF_jid.setLayout(Item.LAYOUT_DEFAULT);// GEN-END:MVDGetInit16
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd16
		return this.tF_jid;
	}// GEN-END:MVDGetEnd16

	/**
	 * This method returns instance for tF_jpw component and should be called
	 * instead of accessing tF_jpw field directly.                         
	 * 
	 * @return Instance for tF_jpw component
	 */
	public TextField get_tF_jpw() {
		if (this.tF_jpw == null) {// GEN-END:MVDGetBegin17
			// Insert pre-init code here
			this.tF_jpw = new TextField("Jabber Password", "", 120, TextField.ANY | TextField.PASSWORD);// GEN-BEGIN:MVDGetInit17
			this.tF_jpw.setLayout(Item.LAYOUT_DEFAULT);// GEN-END:MVDGetInit17
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd17
		return this.tF_jpw;
	}// GEN-END:MVDGetEnd17

	/**
	 * This method returns instance for helpC_login component and should be
	 * called instead of accessing helpC_login field
	 * directly.                         
	 * 
	 * @return Instance for helpC_login component
	 */
	public Command get_helpC_login() {
		if (this.helpC_login == null) {// GEN-END:MVDGetBegin18
			// Insert pre-init code here
			this.helpC_login = new Command("Help", Command.HELP, 3);// GEN-LINE:MVDGetInit18
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd18
		return this.helpC_login;
	}// GEN-END:MVDGetEnd18

	/**
	 * This method returns instance for mainForm component and should be called
	 * instead of accessing mainForm field directly.                         
	 * 
	 * @return Instance for mainForm component
	 */
	public List get_mainForm() {
		if (this.mainForm == null) {// GEN-END:MVDGetBegin35
			// Insert pre-init code here
			this.mainForm = new List("Hauptmen\u00FC", Choice.IMPLICIT, new String[] {// GEN-BEGIN:MVDGetInit35
			        "Login", "Einstellungen", "Exit" }, new Image[] { this.get_image_login(), this.get_image_configuration(), this.get_image_exit() });
			this.mainForm.setCommandListener(this);
			this.mainForm.setSelectedFlags(new boolean[] { false, false, false });// GEN-END:MVDGetInit35
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd35
		return this.mainForm;
	}// GEN-END:MVDGetEnd35

	/**
	 * This method returns instance for buddylist component and should be called
	 * instead of accessing buddylist field directly.                         
	 * 
	 * @return Instance for buddylist component
	 */
	public List get_buddylist() {
		if (this.buddylist == null) {// GEN-END:MVDGetBegin37
			// Insert pre-init code here
			this.buddylist = new List("Buddyliste", Choice.IMPLICIT, new String[0], new Image[0]);// GEN-BEGIN:MVDGetInit37
			this.buddylist.addCommand(this.get_buddyC_del());
			this.buddylist.addCommand(this.get_buddyC_info());
			this.buddylist.addCommand(this.get_buddyC_to_add());
			this.buddylist.addCommand(this.get_buddyC_message());
			this.buddylist.addCommand(this.get_backC_logout());
			this.buddylist.addCommand(this.get_PrecenseC());
			this.buddylist.addCommand(this.get_buddyC_delchat());
			this.buddylist.setCommandListener(this);
			this.buddylist.setSelectedFlags(new boolean[0]);// GEN-END:MVDGetInit37
			// Insert post-init code here
			this.setStatus();
		}// GEN-BEGIN:MVDGetEnd37
		return this.buddylist;
	}// GEN-END:MVDGetEnd37

	/**
	 * This method returns instance for image_login component and should be
	 * called instead of accessing image_login field
	 * directly.                         
	 * 
	 * @return Instance for image_login component
	 */
	public Image get_image_login() {
		if (this.image_login == null) {// GEN-END:MVDGetBegin50
			// Insert pre-init code here
			try {// GEN-BEGIN:MVDGetInit50
				this.image_login = Image.createImage("/res/16/clicknrun.png");
			} catch (final java.io.IOException exception) {
			}// GEN-END:MVDGetInit50
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd50
		return this.image_login;
	}// GEN-END:MVDGetEnd50

	/**
	 * This method returns instance for image_configuration component and should
	 * be called instead of accessing image_configuration field
	 * directly.                         
	 * 
	 * @return Instance for image_configuration component
	 */
	public Image get_image_configuration() {
		if (this.image_configuration == null) {// GEN-END:MVDGetBegin54
			// Insert pre-init code here
			try {// GEN-BEGIN:MVDGetInit54
				this.image_configuration = Image.createImage("/res/16/utilities.png");
			} catch (final java.io.IOException exception) {
			}// GEN-END:MVDGetInit54
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd54
		return this.image_configuration;
	}// GEN-END:MVDGetEnd54

	/**
	 * This method returns instance for configurationForm component and should
	 * be called instead of accessing configurationForm field
	 * directly.                         
	 * 
	 * @return Instance for configurationForm component
	 */
	public List get_configurationForm() {
		if (this.configurationForm == null) {// GEN-END:MVDGetBegin58
			// Insert pre-init code here
			this.configurationForm = new List("Konfiguration", Choice.IMPLICIT, new String[] {// GEN-BEGIN:MVDGetInit58
			        "Neuen Account erstellen", "Zur\u00FCck" }, new Image[] { this.get_image_new(), this.get_image_back() });
			this.configurationForm.setCommandListener(this);
			this.configurationForm.setSelectedFlags(new boolean[] { false, false });// GEN-END:MVDGetInit58
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd58
		return this.configurationForm;
	}// GEN-END:MVDGetEnd58

	/**
	 * This method returns instance for alert_login component and should be
	 * called instead of accessing alert_login field
	 * directly.                         
	 * 
	 * @return Instance for alert_login component
	 */
	public Alert get_alert_login() {
		if (this.alert_login == null) {// GEN-END:MVDGetBegin70
			// Insert pre-init code here
			this.alert_login = new Alert("Login Fehler", "", null, AlertType.WARNING);// GEN-BEGIN:MVDGetInit70
			this.alert_login.addCommand(this.get_backC_to_main());
			this.alert_login.setCommandListener(this);
			this.alert_login.setTimeout(3000);// GEN-END:MVDGetInit70
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd70
		return this.alert_login;
	}// GEN-END:MVDGetEnd70

	/**
	 * This method returns instance for sendenC component and should be called
	 * instead of accessing sendenC field directly.                         
	 * 
	 * @return Instance for sendenC component
	 */
	public Command get_sendenC() {
		if (this.sendenC == null) {// GEN-END:MVDGetBegin82
			// Insert pre-init code here
			this.sendenC = new Command("Senden", Command.ITEM, 1);// GEN-LINE:MVDGetInit82
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd82
		return this.sendenC;
	}// GEN-END:MVDGetEnd82

	/**
	 * This method returns instance for buddyC_del component and should be
	 * called instead of accessing buddyC_del field
	 * directly.                         
	 * 
	 * @return Instance for buddyC_del component
	 */
	public Command get_buddyC_del() {
		if (this.buddyC_del == null) {// GEN-END:MVDGetBegin89
			// Insert pre-init code here
			this.buddyC_del = new Command("Buddy l\u00F6schen", Command.ITEM, 4);// GEN-LINE:MVDGetInit89
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd89
		return this.buddyC_del;
	}// GEN-END:MVDGetEnd89

	/**
	 * This method returns instance for buddyC_info component and should be
	 * called instead of accessing buddyC_info field
	 * directly.                         
	 * 
	 * @return Instance for buddyC_info component
	 */
	public Command get_buddyC_info() {
		if (this.buddyC_info == null) {// GEN-END:MVDGetBegin91
			// Insert pre-init code here
			this.buddyC_info = new Command("Buddy Info", Command.ITEM, 3);// GEN-LINE:MVDGetInit91
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd91
		return this.buddyC_info;
	}// GEN-END:MVDGetEnd91

	/**
	 * This method returns instance for buddyC_to_add component and should be
	 * called instead of accessing buddyC_to_add field
	 * directly.                         
	 * 
	 * @return Instance for buddyC_to_add component
	 */
	public Command get_buddyC_to_add() {
		if (this.buddyC_to_add == null) {// GEN-END:MVDGetBegin95
			// Insert pre-init code here
			this.buddyC_to_add = new Command("Buddy hinzuf\u00FCgen", Command.ITEM, 5);// GEN-LINE:MVDGetInit95
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd95
		return this.buddyC_to_add;
	}// GEN-END:MVDGetEnd95

	/**
	 * This method returns instance for login_success component and should be
	 * called instead of accessing login_success field
	 * directly.                          
	 * 
	 * @return Instance for login_success component
	 */
	public Alert get_login_success() {
		if (this.login_success == null) {// GEN-END:MVDGetBegin110
			// Insert pre-init code here
			this.login_success = new Alert("Erfolgreich eingeloggt", "Welcome ...", null, AlertType.INFO);// GEN-BEGIN:MVDGetInit110
			this.login_success.setTimeout(3000);// GEN-END:MVDGetInit110
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd110
		return this.login_success;
	}// GEN-END:MVDGetEnd110

	/**
	 * This method returns instance for buddyC_message component and should be
	 * called instead of accessing buddyC_message field
	 * directly.                          
	 * 
	 * @return Instance for buddyC_message component
	 */
	public Command get_buddyC_message() {
		if (this.buddyC_message == null) {// GEN-END:MVDGetBegin111
			// Insert pre-init code here
			this.buddyC_message = new Command("Nachricht senden", Command.ITEM, 1);// GEN-LINE:MVDGetInit111
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd111
		return this.buddyC_message;
	}// GEN-END:MVDGetEnd111

	/**
	 * This method returns instance for buddyAddForm component and should be
	 * called instead of accessing buddyAddForm field
	 * directly.                          
	 * 
	 * @return Instance for buddyAddForm component
	 */
	public Form get_buddyAddForm() {
		if (this.buddyAddForm == null) {// GEN-END:MVDGetBegin113
			// Insert pre-init code here
			this.buddyAddForm = new Form("Buddy hinzuf\u00FCgen", new Item[] {// GEN-BEGIN:MVDGetInit113
			        this.get_tF_addbuddy_jid(), this.get_spacer1(), this.get_tF_addbuddy_name(), this.get_spacer2(), this.get_cG_addbuddy_group() });
			this.buddyAddForm.addCommand(this.get_backC_to_buddy());
			this.buddyAddForm.addCommand(this.get_buddyC_add());
			this.buddyAddForm.setCommandListener(this);// GEN-END:MVDGetInit113
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd113
		return this.buddyAddForm;
	}// GEN-END:MVDGetEnd113

	/**
	 * This method returns instance for tF_addbuddy_jid component and should be
	 * called instead of accessing tF_addbuddy_jid field
	 * directly.                          
	 * 
	 * @return Instance for tF_addbuddy_jid component
	 */
	public TextField get_tF_addbuddy_jid() {
		if (this.tF_addbuddy_jid == null) {// GEN-END:MVDGetBegin114
			// Insert pre-init code here
			this.tF_addbuddy_jid = new TextField("JID (+Server)", "tmp_jid", 120, TextField.ANY);// GEN-LINE:MVDGetInit114
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd114
		return this.tF_addbuddy_jid;
	}// GEN-END:MVDGetEnd114

	/**
	 * This method returns instance for backC_to_buddy component and should be
	 * called instead of accessing backC_to_buddy field
	 * directly.                          
	 * 
	 * @return Instance for backC_to_buddy component
	 */
	public Command get_backC_to_buddy() {
		if (this.backC_to_buddy == null) {// GEN-END:MVDGetBegin115
			// Insert pre-init code here
			this.backC_to_buddy = new Command("Back", Command.BACK, 2);// GEN-LINE:MVDGetInit115
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd115
		return this.backC_to_buddy;
	}// GEN-END:MVDGetEnd115

	/**
	 * This method returns instance for buddyC_add component and should be
	 * called instead of accessing buddyC_add field
	 * directly.                          
	 * 
	 * @return Instance for buddyC_add component
	 */
	public Command get_buddyC_add() {
		if (this.buddyC_add == null) {// GEN-END:MVDGetBegin117
			// Insert pre-init code here
			this.buddyC_add = new Command("Hinzuf\u00FCgen", Command.ITEM, 1);// GEN-LINE:MVDGetInit117
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd117
		return this.buddyC_add;
	}// GEN-END:MVDGetEnd117

	/**
	 * This method returns instance for backC_logout component and should be
	 * called instead of accessing backC_logout field
	 * directly.                          
	 * 
	 * @return Instance for backC_logout component
	 */
	public Command get_backC_logout() {
		if (this.backC_logout == null) {// GEN-END:MVDGetBegin147
			// Insert pre-init code here
			this.backC_logout = new Command("Logout", Command.BACK, 6);// GEN-LINE:MVDGetInit147
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd147
		return this.backC_logout;
	}// GEN-END:MVDGetEnd147

	/**
	 * This method returns instance for tF_jserver component and should be
	 * called instead of accessing tF_jserver field
	 * directly.                          
	 * 
	 * @return Instance for tF_jserver component
	 */
	public TextField get_tF_jserver() {
		if (this.tF_jserver == null) {// GEN-END:MVDGetBegin157
			// Insert pre-init code here
			this.tF_jserver = new TextField("Jabber Server", "jabber.ccc.de", 120, TextField.ANY);// GEN-LINE:MVDGetInit157
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd157
		return this.tF_jserver;
	}// GEN-END:MVDGetEnd157

	/**
	 * This method returns instance for tF_jressource component and should be
	 * called instead of accessing tF_jressource field
	 * directly.                          
	 * 
	 * @return Instance for tF_jressource component
	 */
	public TextField get_tF_jressource() {
		if (this.tF_jressource == null) {// GEN-END:MVDGetBegin158
			// Insert pre-init code here
			this.tF_jressource = new TextField("Jabber Ressource", "mobile", 120, TextField.ANY);// GEN-LINE:MVDGetInit158
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd158
		return this.tF_jressource;
	}// GEN-END:MVDGetEnd158

	/**
	 * This method returns instance for PrecenseC component and should be called
	 * instead of accessing PrecenseC field directly.                          
	 * 
	 * @return Instance for PrecenseC component
	 */
	public Command get_PrecenseC() {
		if (this.PrecenseC == null) {// GEN-END:MVDGetBegin163
			// Insert pre-init code here
			this.PrecenseC = new Command("Status", Command.ITEM, 1);// GEN-LINE:MVDGetInit163
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd163
		return this.PrecenseC;
	}// GEN-END:MVDGetEnd163

	/**
	 * This method returns instance for presence component and should be called
	 * instead of accessing presence field directly.                          
	 * 
	 * @return Instance for presence component
	 */
	public Form get_presence() {
		if (this.presence == null) {// GEN-END:MVDGetBegin165
			// Insert pre-init code here
			this.presence = new Form("Status \u00E4ndern", new Item[] { this.get_cG_status() });// GEN-BEGIN:MVDGetInit165
			this.presence.addCommand(this.get_backC_to_buddy());
			this.presence.addCommand(this.get_okC_changeStatus());
			this.presence.setCommandListener(this);// GEN-END:MVDGetInit165
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd165
		return this.presence;
	}// GEN-END:MVDGetEnd165

	/**
	 * This method returns instance for cG_status component and should be called
	 * instead of accessing cG_status field directly.                          
	 * 
	 * @return Instance for cG_status component
	 */
	public ChoiceGroup get_cG_status() {
		if (this.cG_status == null) {// GEN-END:MVDGetBegin166
			// Insert pre-init code here
			this.cG_status = new ChoiceGroup("", Choice.EXCLUSIVE, new String[] {// GEN-BEGIN:MVDGetInit166
			        "Online", "Away", "Not Available", "Do not Disturb", "Invisible" }, new Image[] { this.get_image_S_online(), this.get_image_S_away(), this.get_image_S_xa(), this.get_image_S_dnd(), this.get_image_S_invisible() });
			this.cG_status.setSelectedFlags(new boolean[] { true, false, false, false, false });// GEN-END:MVDGetInit166
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd166
		return this.cG_status;
	}// GEN-END:MVDGetEnd166

	/**
	 * This method returns instance for image_exit component and should be
	 * called instead of accessing image_exit field
	 * directly.                          
	 * 
	 * @return Instance for image_exit component
	 */
	public Image get_image_exit() {
		if (this.image_exit == null) {// GEN-END:MVDGetBegin172
			// Insert pre-init code here
			try {// GEN-BEGIN:MVDGetInit172
				this.image_exit = Image.createImage("/res/16/exit.png");
			} catch (final java.io.IOException exception) {
			}// GEN-END:MVDGetInit172
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd172
		return this.image_exit;
	}// GEN-END:MVDGetEnd172

	/**
	 * This method returns instance for image_back component and should be
	 * called instead of accessing image_back field
	 * directly.                          
	 * 
	 * @return Instance for image_back component
	 */
	public Image get_image_back() {
		if (this.image_back == null) {// GEN-END:MVDGetBegin173
			// Insert pre-init code here
			try {// GEN-BEGIN:MVDGetInit173
				this.image_back = Image.createImage("/res/16/back.png");
			} catch (final java.io.IOException exception) {
			}// GEN-END:MVDGetInit173
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd173
		return this.image_back;
	}// GEN-END:MVDGetEnd173

	/**
	 * This method returns instance for image_new component and should be called
	 * instead of accessing image_new field directly.                          
	 * 
	 * @return Instance for image_new component
	 */
	public Image get_image_new() {
		if (this.image_new == null) {// GEN-END:MVDGetBegin174
			// Insert pre-init code here
			try {// GEN-BEGIN:MVDGetInit174
				this.image_new = Image.createImage("/res/16/new.png");
			} catch (final java.io.IOException exception) {
			}// GEN-END:MVDGetInit174
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd174
		return this.image_new;
	}// GEN-END:MVDGetEnd174

	/**
	 * This method returns instance for image_edit component and should be
	 * called instead of accessing image_edit field
	 * directly.                          
	 * 
	 * @return Instance for image_edit component
	 */
	public Image get_image_edit() {
		if (this.image_edit == null) {// GEN-END:MVDGetBegin175
			// Insert pre-init code here
			try {// GEN-BEGIN:MVDGetInit175
				this.image_edit = Image.createImage("/res/16/edit.png");
			} catch (final java.io.IOException exception) {
			}// GEN-END:MVDGetInit175
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd175
		return this.image_edit;
	}// GEN-END:MVDGetEnd175

	/**
	 * This method returns instance for image_S_invisible component and should
	 * be called instead of accessing image_S_invisible field
	 * directly.                          
	 * 
	 * @return Instance for image_S_invisible component
	 */
	public Image get_image_S_invisible() {
		if (this.image_S_invisible == null) {// GEN-END:MVDGetBegin176
			// Insert pre-init code here
			try {// GEN-BEGIN:MVDGetInit176
				this.image_S_invisible = Image.createImage("/res/16/S_offline.png");
			} catch (final java.io.IOException exception) {
			}// GEN-END:MVDGetInit176
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd176
		return this.image_S_invisible;
	}// GEN-END:MVDGetEnd176

	/**
	 * This method returns instance for image_S_away component and should be
	 * called instead of accessing image_S_away field
	 * directly.                          
	 * 
	 * @return Instance for image_S_away component
	 */
	public Image get_image_S_away() {
		if (this.image_S_away == null) {// GEN-END:MVDGetBegin177
			// Insert pre-init code here
			try {// GEN-BEGIN:MVDGetInit177
				this.image_S_away = Image.createImage("/res/16/S_away.png");
			} catch (final java.io.IOException exception) {
			}// GEN-END:MVDGetInit177
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd177
		return this.image_S_away;
	}// GEN-END:MVDGetEnd177

	/**
	 * This method returns instance for image_S_xa component and should be
	 * called instead of accessing image_S_xa field
	 * directly.                          
	 * 
	 * @return Instance for image_S_xa component
	 */
	public Image get_image_S_xa() {
		if (this.image_S_xa == null) {// GEN-END:MVDGetBegin178
			// Insert pre-init code here
			try {// GEN-BEGIN:MVDGetInit178
				this.image_S_xa = Image.createImage("/res/16/S_xa.png");
			} catch (final java.io.IOException exception) {
			}// GEN-END:MVDGetInit178
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd178
		return this.image_S_xa;
	}// GEN-END:MVDGetEnd178

	/**
	 * This method returns instance for image_S_dnd component and should be
	 * called instead of accessing image_S_dnd field
	 * directly.                          
	 * 
	 * @return Instance for image_S_dnd component
	 */
	public Image get_image_S_dnd() {
		if (this.image_S_dnd == null) {// GEN-END:MVDGetBegin179
			// Insert pre-init code here
			try {// GEN-BEGIN:MVDGetInit179
				this.image_S_dnd = Image.createImage("/res/16/S_dnd.png");
			} catch (final java.io.IOException exception) {
			}// GEN-END:MVDGetInit179
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd179
		return this.image_S_dnd;
	}// GEN-END:MVDGetEnd179

	/**
	 * This method returns instance for image_S_online component and should be
	 * called instead of accessing image_S_online field
	 * directly.                          
	 * 
	 * @return Instance for image_S_online component
	 */
	public Image get_image_S_online() {
		if (this.image_S_online == null) {// GEN-END:MVDGetBegin180
			// Insert pre-init code here
			try {// GEN-BEGIN:MVDGetInit180
				this.image_S_online = Image.createImage("/res/16/S_online.png");
			} catch (final java.io.IOException exception) {
			}// GEN-END:MVDGetInit180
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd180
		return this.image_S_online;
	}// GEN-END:MVDGetEnd180

	/**
	 * This method returns instance for loginC component and should be called
	 * instead of accessing loginC field directly.                          
	 * 
	 * @return Instance for loginC component
	 */
	public Command get_loginC() {
		if (this.loginC == null) {// GEN-END:MVDGetBegin185
			// Insert pre-init code here
			this.loginC = new Command("Login", Command.ITEM, 1);// GEN-LINE:MVDGetInit185
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd185
		return this.loginC;
	}// GEN-END:MVDGetEnd185

	/**
	 * This method returns instance for tF_addbuddy_name component and should be
	 * called instead of accessing tF_addbuddy_name field
	 * directly.                          
	 * 
	 * @return Instance for tF_addbuddy_name component
	 */
	public TextField get_tF_addbuddy_name() {
		if (this.tF_addbuddy_name == null) {// GEN-END:MVDGetBegin188
			// Insert pre-init code here
			this.tF_addbuddy_name = new TextField("Name", "tmp_name", 120, TextField.ANY);// GEN-LINE:MVDGetInit188
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd188
		return this.tF_addbuddy_name;
	}// GEN-END:MVDGetEnd188

	/**
	 * This method returns instance for cG_addbuddy_group component and should
	 * be called instead of accessing cG_addbuddy_group field
	 * directly.                          
	 * 
	 * @return Instance for cG_addbuddy_group component
	 */
	public ChoiceGroup get_cG_addbuddy_group() {
		if (this.cG_addbuddy_group == null) {// GEN-END:MVDGetBegin190
			// Insert pre-init code here
			this.cG_addbuddy_group = new ChoiceGroup("Gruppe", Choice.POPUP, new String[] {// GEN-BEGIN:MVDGetInit190
			        "//eventuell vorhandene Gruppen kommen hier rein", "Gruppe1", "Gruppe2" }, new Image[] { null, null, null });
			this.cG_addbuddy_group.setSelectedFlags(new boolean[] { false, false, false });// GEN-END:MVDGetInit190
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd190
		return this.cG_addbuddy_group;
	}// GEN-END:MVDGetEnd190

	/**
	 * This method returns instance for spacer1 component and should be called
	 * instead of accessing spacer1 field directly.                          
	 * 
	 * @return Instance for spacer1 component
	 */
	public Spacer get_spacer1() {
		if (this.spacer1 == null) {// GEN-END:MVDGetBegin195
			// Insert pre-init code here
			this.spacer1 = new Spacer(1000, 1);// GEN-LINE:MVDGetInit195
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd195
		return this.spacer1;
	}// GEN-END:MVDGetEnd195

	/**
	 * This method returns instance for spacer2 component and should be called
	 * instead of accessing spacer2 field directly.                          
	 * 
	 * @return Instance for spacer2 component
	 */
	public Spacer get_spacer2() {
		if (this.spacer2 == null) {// GEN-END:MVDGetBegin196
			// Insert pre-init code here
			this.spacer2 = new Spacer(1000, 1);// GEN-LINE:MVDGetInit196
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd196
		return this.spacer2;
	}// GEN-END:MVDGetEnd196

	/**
	 * This method returns instance for spacer3 component and should be called
	 * instead of accessing spacer3 field directly.                          
	 * 
	 * @return Instance for spacer3 component
	 */
	public Spacer get_spacer3() {
		if (this.spacer3 == null) {// GEN-END:MVDGetBegin197
			// Insert pre-init code here
			this.spacer3 = new Spacer(1000, 10);// GEN-LINE:MVDGetInit197
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd197
		return this.spacer3;
	}// GEN-END:MVDGetEnd197

	/**
	 * This method returns instance for spacer4 component and should be called
	 * instead of accessing spacer4 field directly.                          
	 * 
	 * @return Instance for spacer4 component
	 */
	public Spacer get_spacer4() {
		if (this.spacer4 == null) {// GEN-END:MVDGetBegin198
			// Insert pre-init code here
			this.spacer4 = new Spacer(1000, 10);// GEN-LINE:MVDGetInit198
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd198
		return this.spacer4;
	}// GEN-END:MVDGetEnd198

	/**
	 * This method returns instance for spacer5 component and should be called
	 * instead of accessing spacer5 field directly.                          
	 * 
	 * @return Instance for spacer5 component
	 */
	public Spacer get_spacer5() {
		if (this.spacer5 == null) {// GEN-END:MVDGetBegin199
			// Insert pre-init code here
			this.spacer5 = new Spacer(1000, 10);// GEN-LINE:MVDGetInit199
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd199
		return this.spacer5;
	}// GEN-END:MVDGetEnd199

	/**
	 * This method returns instance for message_Form component and should be
	 * called instead of accessing message_Form field
	 * directly.                          
	 * 
	 * @return Instance for message_Form component
	 */
	public Form get_message_Form() {
		if (this.message_Form == null) {// GEN-END:MVDGetBegin201
			// Insert pre-init code here
			this.message_Form = new Form("Chat", new Item[] {// GEN-BEGIN:MVDGetInit201
			        this.get_sI_chat(), this.get_spacer6(), this.get_tF_message() });
			this.message_Form.addCommand(this.get_backC_to_buddy());
			this.message_Form.setCommandListener(this);// GEN-END:MVDGetInit201
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd201
		return this.message_Form;
	}// GEN-END:MVDGetEnd201

	/**
	 * This method returns instance for tF_message component and should be
	 * called instead of accessing tF_message field
	 * directly.                          
	 * 
	 * @return Instance for tF_message component
	 */
	public TextField get_tF_message() {
		if (this.tF_message == null) {// GEN-END:MVDGetBegin205
			// Insert pre-init code here
			this.tF_message = new TextField("Message", "test", 120, TextField.ANY);// GEN-BEGIN:MVDGetInit205
			this.tF_message.addCommand(this.get_chatC_Senden());
			this.tF_message.setItemCommandListener(this);// GEN-END:MVDGetInit205
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd205
		return this.tF_message;
	}// GEN-END:MVDGetEnd205

	/**
	 * This method returns instance for spacer6 component and should be called
	 * instead of accessing spacer6 field directly.                          
	 * 
	 * @return Instance for spacer6 component
	 */
	public Spacer get_spacer6() {
		if (this.spacer6 == null) {// GEN-END:MVDGetBegin206
			// Insert pre-init code here
			this.spacer6 = new Spacer(1000, 10);// GEN-LINE:MVDGetInit206
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd206
		return this.spacer6;
	}// GEN-END:MVDGetEnd206

	/**
	 * This method returns instance for chatC_Senden component and should be
	 * called instead of accessing chatC_Senden field
	 * directly.                          
	 * 
	 * @return Instance for chatC_Senden component
	 */
	public Command get_chatC_Senden() {
		if (this.chatC_Senden == null) {// GEN-END:MVDGetBegin207
			// Insert pre-init code here
			this.chatC_Senden = new Command("OK", Command.OK, 1);// GEN-LINE:MVDGetInit207
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd207
		return this.chatC_Senden;
	}// GEN-END:MVDGetEnd207

	/**
	 * This method returns instance for font_small component and should be
	 * called instead of accessing font_small field
	 * directly.                          
	 * 
	 * @return Instance for font_small component
	 */
	public Font get_font_small() {
		if (this.font_small == null) {// GEN-END:MVDGetBegin210
			// Insert pre-init code here
			this.font_small = Font.getFont(Font.FACE_SYSTEM, 0x0, Font.SIZE_SMALL);// GEN-LINE:MVDGetInit210
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd210
		return this.font_small;
	}// GEN-END:MVDGetEnd210

	/**
	 * This method returns instance for sI_chat component and should be called
	 * instead of accessing sI_chat field directly.                          
	 * 
	 * @return Instance for sI_chat component
	 */
	public StringItem get_sI_chat() {
		if (this.sI_chat == null) {// GEN-END:MVDGetBegin211
			// Insert pre-init code here
			this.sI_chat = new StringItem("Chat", "");// GEN-BEGIN:MVDGetInit211
			this.sI_chat.setLayout(Item.LAYOUT_DEFAULT);
			this.sI_chat.setFont(this.get_font_small());// GEN-END:MVDGetInit211
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd211
		return this.sI_chat;
	}// GEN-END:MVDGetEnd211

	/**
	 * This method returns instance for Waitscreen_login component and should be
	 * called instead of accessing Waitscreen_login field
	 * directly.                          
	 * 
	 * @return Instance for Waitscreen_login component
	 */
	public Form get_Waitscreen_login() {
		if (this.Waitscreen_login == null) {// GEN-END:MVDGetBegin221
			// Insert pre-init code here
			this.Waitscreen_login = new Form("Waitscreen", new Item[] {// GEN-BEGIN:MVDGetInit221
			        this.get_sI_waitscreen(), this.get_imageItem_waitscreen() });
			this.Waitscreen_login.addCommand(this.get_tmp());
			this.Waitscreen_login.addCommand(this.get_tmpp());
			this.Waitscreen_login.setCommandListener(this);// GEN-END:MVDGetInit221
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd221
		return this.Waitscreen_login;
	}// GEN-END:MVDGetEnd221

	/**
	 * This method returns instance for sI_waitscreen component and should be
	 * called instead of accessing sI_waitscreen field
	 * directly.                          
	 * 
	 * @return Instance for sI_waitscreen component
	 */
	public StringItem get_sI_waitscreen() {
		if (this.sI_waitscreen == null) {// GEN-END:MVDGetBegin222
			// Insert pre-init code here
			this.sI_waitscreen = new StringItem("\nBitte warten...", "");// GEN-BEGIN:MVDGetInit222
			this.sI_waitscreen.setLayout(Item.LAYOUT_CENTER | Item.LAYOUT_VCENTER);// GEN-END:MVDGetInit222
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd222
		return this.sI_waitscreen;
	}// GEN-END:MVDGetEnd222

	/**
	 * This method returns instance for imageItem_waitscreen component and
	 * should be called instead of accessing imageItem_waitscreen field
	 * directly.                          
	 * 
	 * @return Instance for imageItem_waitscreen component
	 */
	public ImageItem get_imageItem_waitscreen() {
		if (this.imageItem_waitscreen == null) {// GEN-END:MVDGetBegin223
			// Insert pre-init code here
			this.imageItem_waitscreen = new ImageItem("", this.get_image_waitscreen_login(), Item.LAYOUT_CENTER | Item.LAYOUT_VCENTER, null);// GEN-LINE:MVDGetInit223
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd223
		return this.imageItem_waitscreen;
	}// GEN-END:MVDGetEnd223

	/**
	 * This method returns instance for image_waitscreen_login component and
	 * should be called instead of accessing image_waitscreen_login field
	 * directly.                          
	 * 
	 * @return Instance for image_waitscreen_login component
	 */
	public Image get_image_waitscreen_login() {
		if (this.image_waitscreen_login == null) {// GEN-END:MVDGetBegin224
			// Insert pre-init code here
			try {// GEN-BEGIN:MVDGetInit224
				this.image_waitscreen_login = Image.createImage("/res/down1.gif");
			} catch (final java.io.IOException exception) {
			}// GEN-END:MVDGetInit224
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd224
		return this.image_waitscreen_login;
	}// GEN-END:MVDGetEnd224

	/**
	 * This method returns instance for tmp component and should be called
	 * instead of accessing tmp field directly.                          
	 * 
	 * @return Instance for tmp component
	 */
	public Command get_tmp() {
		if (this.tmp == null) {// GEN-END:MVDGetBegin226
			// Insert pre-init code here
			this.tmp = new Command(">", Command.ITEM, 1);// GEN-LINE:MVDGetInit226
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd226
		return this.tmp;
	}// GEN-END:MVDGetEnd226

	/**
	 * This method returns instance for tmpp component and should be called
	 * instead of accessing tmpp field directly.                          
	 * 
	 * @return Instance for tmpp component
	 */
	public Command get_tmpp() {
		if (this.tmpp == null) {// GEN-END:MVDGetBegin228
			// Insert pre-init code here
			this.tmpp = new Command("<", Command.ITEM, 1);// GEN-LINE:MVDGetInit228
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd228
		return this.tmpp;
	}// GEN-END:MVDGetEnd228

	/**
	 * This method returns instance for image_S_chat component and should be
	 * called instead of accessing image_S_chat field
	 * directly.                          
	 * 
	 * @return Instance for image_S_chat component
	 */
	public Image get_image_S_chat() {
		if (this.image_S_chat == null) {// GEN-END:MVDGetBegin230
			// Insert pre-init code here
			try {// GEN-BEGIN:MVDGetInit230
				this.image_S_chat = Image.createImage("/res/16/S_chat.png");
			} catch (final java.io.IOException exception) {
			}// GEN-END:MVDGetInit230
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd230
		return this.image_S_chat;
	}// GEN-END:MVDGetEnd230

	/**
	 * This method returns instance for image_S_message component and should be
	 * called instead of accessing image_S_message field
	 * directly.                          
	 * 
	 * @return Instance for image_S_message component
	 */
	public Image get_image_S_message() {
		if (this.image_S_message == null) {// GEN-END:MVDGetBegin232
			// Insert pre-init code here
			try {// GEN-BEGIN:MVDGetInit232
				this.image_S_message = Image.createImage("/res/16/S_message_in.png");
			} catch (final java.io.IOException exception) {
			}// GEN-END:MVDGetInit232
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd232
		return this.image_S_message;
	}// GEN-END:MVDGetEnd232

	/**
	 * This method returns instance for spacer7 component and should be called
	 * instead of accessing spacer7 field directly.                          
	 * 
	 * @return Instance for spacer7 component
	 */
	public Spacer get_spacer7() {
		if (this.spacer7 == null) {// GEN-END:MVDGetBegin233
			// Insert pre-init code here
			this.spacer7 = new Spacer(1000, 10);// GEN-LINE:MVDGetInit233
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd233
		return this.spacer7;
	}// GEN-END:MVDGetEnd233

	/**
	 * This method returns instance for jpriority component and should be called
	 * instead of accessing jpriority field directly.                          
	 * 
	 * @return Instance for jpriority component
	 */
	public TextField get_jpriority() {
		if (this.jpriority == null) {// GEN-END:MVDGetBegin239
			// Insert pre-init code here
			this.jpriority = new TextField("Priorit\u00E4t", "1", 2, TextField.NUMERIC);// GEN-LINE:MVDGetInit239
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd239
		return this.jpriority;
	}// GEN-END:MVDGetEnd239

	/**
	 * This method returns instance for image_S_null component and should be
	 * called instead of accessing image_S_null field
	 * directly.                          
	 * 
	 * @return Instance for image_S_null component
	 */
	public Image get_image_S_null() {
		if (this.image_S_null == null) {// GEN-END:MVDGetBegin241
			// Insert pre-init code here
			try {// GEN-BEGIN:MVDGetInit241
				this.image_S_null = Image.createImage("<No Image>");
			} catch (final java.io.IOException exception) {
			}// GEN-END:MVDGetInit241
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd241
		return this.image_S_null;
	}// GEN-END:MVDGetEnd241

	/**
	 * This method returns instance for buddyC_delchat component and should be
	 * called instead of accessing buddyC_delchat field
	 * directly.                          
	 * 
	 * @return Instance for buddyC_delchat component
	 */
	public Command get_buddyC_delchat() {
		if (this.buddyC_delchat == null) {// GEN-END:MVDGetBegin244
			// Insert pre-init code here
			this.buddyC_delchat = new Command("Chat history l\u00F6schen", Command.ITEM, 5);// GEN-LINE:MVDGetInit244
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd244
		return this.buddyC_delchat;
	}// GEN-END:MVDGetEnd244

	/**
	 * This method returns instance for okC_changeStatus component and should be
	 * called instead of accessing okC_changeStatus field
	 * directly.                          
	 * 
	 * @return Instance for okC_changeStatus component
	 */
	public Command get_okC_changeStatus() {
		if (this.okC_changeStatus == null) {// GEN-END:MVDGetBegin246
			// Insert pre-init code here
			this.okC_changeStatus = new Command("OK", Command.OK, 1);// GEN-LINE:MVDGetInit246
			// Insert post-init code here
		}// GEN-BEGIN:MVDGetEnd246
		return this.okC_changeStatus;
	}// GEN-END:MVDGetEnd246

	public void startApp() {
		this.initialize();
	}

	public void pauseApp() {}

	public void destroyApp(final boolean unconditional) {}

	public void login() {
		jxa = new Jxa(this.tF_jserver.getString(), "5222", this.tF_jid.getString(), this.tF_jpw.getString(), "mobile", TextField.NUMERIC);
                jxa.addListener(this);
	}

	public void logout() {
		jxa.logoff();
		System.out.println("logout_erfolgreich");
		this.setStatus();
	}

	public void setStatus() {
		this.buddylist.deleteAll();
		this.buddylist.append(this.tF_jid.getString(), this.get_image_S_online());
		this.buddylist.append("----", this.get_image_S_null());
	}

	public void changeStatus() {
		String sta = "";

		this.buddylist.delete(0);
		switch (this.cG_status.getSelectedIndex()) {
			case 0:
				sta = "online";
				this.buddylist.insert(0, this.tF_jid.getString(), this.get_image_S_online());
				break;
			case 1:
				sta = "away";
				this.buddylist.insert(0, this.tF_jid.getString(), this.get_image_S_away());
				break;
			case 2:
				sta = "xa";
				this.buddylist.insert(0, this.tF_jid.getString(), this.get_image_S_xa());
				break;
			case 3:
				sta = "dnd";
				this.buddylist.insert(0, this.tF_jid.getString(), this.get_image_S_dnd());
				break;
			case 4:
				sta = "invisible";
				this.buddylist.insert(0, this.tF_jid.getString(), this.get_image_S_invisible());
				break;
		}

		jxa.setStatus(sta, sta, TextField.NUMERIC);
		java.lang.System.out.println("jxa.setStatus(" + sta + ", " + sta + ", " + TextField.NUMERIC + ");");
	}

	public void addBuddy() {
		this.buddylist.append(this.tF_addbuddy_jid.getString(), this.get_image_S_invisible());
	}

	public void delBuddy() {

		final int i = this.buddylist.getSelectedIndex();
		if (this.buddylist.getSelectedIndex() > 1) {
			this.onContactRemoveEvent(this.buddylist.getString(i));
			java.lang.System.out.println(this.buddylist.getString(i).toString());
			this.buddylist.delete(i);
		} else {
			java.lang.System.out.println(i);
			java.lang.System.out.println("Bitte ein Buddy auswhlen!");
		}
	}

	public void onAuth() {
		java.lang.System.out.println("*debug* authorized");
		try {
			jxa.getRoster();
		} catch (final IOException ex) {
			ex.printStackTrace();
		}
		this.getDisplay().setCurrent(this.get_buddylist());
	}

	public void onAuthFailed(final String message) {
		java.lang.System.out.println("*debug* not authorized");
		java.lang.System.out.println(message);
		this.getDisplay().setCurrent(this.get_alert_login());
		this.alert_login.setString("not authorized: " + message);
	}

	public void onConnFailed() {
		java.lang.System.out.println("*debug* connection failed");
		this.getDisplay().setCurrent(this.get_alert_login());
		this.alert_login.setString("connection failed");
	}

	public String shortjid(String jid) {
		final int PunktIndex = jid.indexOf("@");
		if (PunktIndex > 1) {
			jid = jid.substring(0, PunktIndex);
		}
		return jid;
	}

	// if a message arrive, it will be saved and icon in buddylist change
	public void onMessageEvent(final String from, final String body) {
		java.lang.System.out.println("*debug* message  von: " + from);
		java.lang.System.out.println("*debug* message text: " + body);

		for (int i = 0; i < (this.buddylist.size()); i++) {
			if (this.buddylist.getString(i).equals(from)) {
				this.buddylist.delete(i);
				this.buddylist.insert(i, from, this.get_image_S_message());
				this.setTime();
				this.roster.save_Message_ex(this.shortjid(from), " [" + this.strDate + "] - " + body);
				if (this.getDisplay().getCurrent().equals(this.message_Form)) {
					java.lang.System.out.println("rec = " + this.rec);
					if (this.shortjid(this.rec).equals(this.shortjid(from))) {
						this.sI_chat.setText(this.roster.get_Messages(this.shortjid(from), this.tF_jid.getString()));
					}
				}
			}
		}
		AlertType.INFO.playSound(Display.getDisplay(this));
		java.lang.System.out.println("*debug* " + this.roster.get_allMessages());
	}

	public void onContactRemoveEvent(final String jid) {
		java.lang.System.out.println("*debug* onContactRemoveEvent(" + jid + ")");
	}

	public void onContactEvent(final String jid, final String name, final String group, final String subscription) {
		java.lang.System.out.println("*debug* onContactEvent(" + jid + ", " + name + ", " + group + ", " + subscription + ")");
		this.buddylist.append(jid, this.get_image_S_invisible());
		try {
			// roster.show.put(new String("test"), new Integer(1));
			// java.lang.System.out.println("*debug*
			// roster="+roster.show.get("test"));
			// roster.buddy_id.put(jid,String.valueOf(buddylist.size()));
		} catch (final Exception e) {
			e.printStackTrace();
		}
	}

	public void onSubscribeEvent(final String jid) {
		java.lang.System.out.println("*debug* SubscribeEvent von " + jid);
	}

	public void onUnsubscribeEvent(final String jid) {
		java.lang.System.out.println("*debug* UnsubscribeEvent von" + jid);
	}

	public void onStatusEvent(final String jid, String show, final String status) {
		java.lang.System.out.println("*debug* onStatusEvent(" + jid + ", " + show + ", " + status + ")");
		if (show == null) {
			show = "";
		}

		for (int i = 0; i < (this.buddylist.size()); i++) {
			if (this.buddylist.getString(i).equals(jid)) {
				this.buddylist.delete(i);
				switch (((Integer) this.shows.get(show)).intValue()) {
					case 0:
						this.buddylist.insert(i, jid, this.get_image_S_online());
						this.roster.set_Buddystatus(jid, show);
						break;
					case 1:
						this.buddylist.insert(i, jid, this.get_image_S_chat());
						break;
					case 2:
						this.buddylist.insert(i, jid, this.get_image_S_away());
						break;
					case 3:
						this.buddylist.insert(i, jid, this.get_image_S_xa());
						break;
					case 4:
						this.buddylist.insert(i, jid, this.get_image_S_dnd());
						break;
				}
			}
		}
	}

	public void setTime() {
		this.cal.setTime(new Date());
		if ((this.cal.get(Calendar.HOUR) + 2) < 10) {
			this.strDate = "0" + (this.cal.get(Calendar.HOUR) + 2) + ":";
		} else {
			this.strDate = (this.cal.get(Calendar.HOUR) + 2) + ":";
		}

		if (this.cal.get(Calendar.MINUTE) < 10) {
			this.strDate += "0" + this.cal.get(Calendar.MINUTE);
		} else {
			this.strDate += this.cal.get(Calendar.MINUTE);
		}
	}

	public void messageSend() {
		final String message = this.tF_message.getString();
		this.messagesendto = this.tF_jid.getString();
		this.setTime();
		jxa.sendMessage(this.rec, message);
		this.roster.save_Message_in(this.messagesendto, this.shortjid(this.rec), " [" + this.strDate + "]: " + message);
		this.sI_chat.setText(this.roster.get_Messages(this.shortjid(this.rec), this.shortjid(this.messagesendto)));
		java.lang.System.out.println("sI_chat.setText(roster.get_Messages(" + this.shortjid(this.rec) + ", " + this.shortjid(this.messagesendto) + ")");
	}
}
